package fishrungames.bashgid;



import fishrungames.networkutils.ImageManager;
import fishrungames.bashgid.core.JournalManager.JournalSemiFullData;
import fishrungames.bashgid.core.NewsManager.NewsRecord;
import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;


public class NewsListFragment extends Fragment
{

	ListView listView;
	
	ListAdapter listAdapter;
	
	JournalSemiFullData journal;
	
	@SuppressLint("InflateParams") @Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.fragment_news_page, container, false);
		
		journal = MainActivity.getInstance().journalDataSource.GetJournalSemiFullData("news");

		listView = (ListView) rootView.findViewById(R.id.listView);
		
		listAdapter = new ListAdapter(getActivity());
		
		listView.setAdapter(listAdapter);
		
		View header = inflater.inflate(R.layout.news_page_list_header, null);
		
		listView.addHeaderView(header);
		
		listView.setOnItemClickListener(new OnItemClickListener(){

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id)
			{
				MainActivity.getInstance().OpenArticleScreen(journal.articleArr.get(position).name, MainActivity.TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT);
			}
		
		});
	
		return rootView;
	}
	
	
	public void RefreshNewsList()
	{
		journal = MainActivity.getInstance().journalDataSource.GetJournalSemiFullData("news");

		listAdapter.notifyDataSetChanged();
	}
	
	public class ListAdapter extends BaseAdapter {
	    private Context mContext;

	    public ListAdapter(Context c) {
	        mContext = c;
	    }

	    public int getCount() {
	        return journal.articleArr.size();
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.journal_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView titleTextView = (TextView)view.findViewById(R.id.titleTextView);
	    
	        titleTextView.setText(journal.articleArr.get(position).title);
	        
	        TextView dateTextView = (TextView)view.findViewById(R.id.dateTextView);
		    
	        dateTextView.setText(journal.articleArr.get(position).dateTime.toString());
	        	        
	        if (journal.previewImageArr.get(position) != null)
	        {
	        ImageView imageView = (ImageView) view.findViewById(R.id.imageView);
	        
	        ImageManager.getInstance().ApplyImageToImageView(imageView, journal.previewImageArr.get(position));
	        
	        }
	        return view;
	    }

	}
	

	public static class ButtonOnClickListener implements OnClickListener
	{
		
		NewsRecord newsRecord;
		
		public ButtonOnClickListener(NewsRecord newsRecord)
		{
			this.newsRecord = newsRecord;
		}

		@Override
		public void onClick(View v)
		{
			//MainActivity.getInstance().OpenNewsRecordScreen(newsRecord, MainActivity.TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT);
		}
		
	}
	
}
