package fishrungames.bashgid;


import fishrungames.networkutils.ImageManager;
import fishrungames.bashgid.core.ArticleManager.ArticleFullData;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.ImageView;
import android.widget.TextView;


public class NewsRecordFragment extends Fragment
{
	
	String articleName;
	
	ArticleFullData articleData;
	
	public NewsRecordFragment()
	{
		this.articleName = "";
		this.articleData = null;
	}
	
	public NewsRecordFragment(String articleName)
	{
		this.articleName = articleName;
		RestoreArticle();
	}
	
	@Override
    public void onSaveInstanceState(final Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putString("articleName", articleName);       
    }
	
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		
		if (savedInstanceState != null) {
			articleName = savedInstanceState.getString("articleName");
			RestoreArticle();
        }
		
		View rootView = inflater.inflate(R.layout.fragment_news_record_page, container, false);
		
		TextView titleTextView = (TextView) rootView.findViewById(R.id.titleTextView);
		titleTextView.setText(articleData.title);
		
		//ImageView imageView = (ImageView) rootView.findViewById(R.id.imageView);
		//ImageManager.getInstance().ApplyImageToImageView(imageView, articleData.);
		
		WebView webView = (WebView) rootView.findViewById(R.id.webView);
		
		webView.getSettings().setJavaScriptEnabled(false);
		
		String htmlCode = "<html><body>" + articleData.content + "</body></html>";
		
		webView.loadDataWithBaseURL(null, htmlCode, "text/html", "UTF-8", null);
		
		return rootView;
	}
	
	public void RestoreArticle()
	{
		articleData = MainActivity.getInstance().articleDataSource.GetArticleFullData(articleName);
	}
	
	
}
