package fishrungames.bashgid.core;

import java.util.ArrayList;

import fishrungames.bashgid.core.ArticleManager.ArticleFullData;
import fishrungames.bashgid.core.ArticleManager.ArticleRecordData;


public class JournalManager
{
	
	public static class JournalRecordData
	{
		public String name;
		public String title;
		public String description;
		
		
		public JournalRecordData(String name, String title, String description)
		{
			this.name = name;
			this.title = title;
			this.description = description;
		}
		
		public JournalRecordData(JournalRecordData copyFrom)
		{
			this.name = copyFrom.name;
			this.title = copyFrom.title;
			this.description = copyFrom.description;
		}
	}
	
	public static class JournalSemiFullData extends JournalRecordData
	{

		public ArrayList<ArticleRecordData> articleArr;
		public ArrayList<String> previewImageArr;
		
		public JournalSemiFullData(JournalRecordData copyFrom)
		{
			super(copyFrom);
			articleArr = new ArrayList<ArticleRecordData>();
			previewImageArr = new ArrayList<String>();
		}
		
	}
	
	
	public static class JournalRecord extends JournalRecordData
	{
		public int id;
		
		public JournalRecord(int id, String name, String title, String description)
		{
			super(name, title, description);
			this.id = id;
		}
	}
	
	
	
}
